pipeline {
	agent any
	parameters {
		string ( 
			name: "VM_USER",
			defaultValue: "ubuntu"
		)
		string (
			name: "VM_IP",
			defaultValue: "35.153.143.230"
		)
		string (
			name: "REGISTRY_URL",
			defaultValue: "registry-itau.mastertech.com.br"
		)
		string (
			name: "IMAGE",
			defaultValue: "api_invest_marco_simoes"
		)
	}
	stages {
		stage("Início de execução") {
			steps {
				echo "Início de execução"
			}
		}
		stage("Execução de testes") {
			steps {
				sh "./mvnw test"
				echo "Testes executados"
			}
		}
		stage("Criação de pacote") {
			steps {
				sh "./mvnw clean package -DskipTests"
				echo "Pacote limpo e criado"
			}
		}
		stage("Deploy para expor aplicação via serviço na EC2 AWS") {
			when {branch 'master'}
			stages {
				stage("Envio de arquivo .jar  para a máquina AWS") {
					steps {
						script {
							def targetPath = sh (
								script: "find target/ -name 'Api-Investimentos-*.jar'",
								returnStdout: true
							).trim()
							sh "scp -o StrictHostKeyChecking=no ${targetPath} ${params.VM_USER}@${params.VM_IP}:/home/${params.VM_USER}/aplicacoes"
							echo "Pacote enviado com sucesso"
						}
					}
				}
				stage("Reiniciar o serviço na máquina AWS com a nova versão do pacote") {
					steps {
						sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} sudo systemctl restart api-investimentos.service"
						echo "Serviço reiniciado"
						
						sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} sudo systemctl stop api-investimentos.service"
						echo "Serviço parado para execução da aplicação em container"
					}
				}
			}
		}
		stage("Deploy para expor aplicação em container Docker") {
			when {branch 'master'}
			stages {
				stage("Build e push da imagem") {
					steps {
						script {
							docker.withRegistry("https://${params.REGISTRY_URL}","registry_credential") {
								def customImage=docker.build("${params.REGISTRY_URL}/${params.IMAGE}")
								customImage.push("${env.BUILD_ID}")
								customImage.push("latest")

								echo "Build e push executados"
							}
						}
					}
				}
				stage("Pull da imagem e run do container") {
					steps {
						sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker pull ${params.REGISTRY_URL}/${params.IMAGE}:latest'"
						sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker stop ${params.IMAGE}'"

						sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USER}@${params.VM_IP} 'docker run --rm -p 8080:8080 -d --name ${params.IMAGE} ${params.REGISTRY_URL}/${params.IMAGE}:latest'"
					}
				}
			}
		}
	}
}
